<template>
  <div class="p-2">
    <div v-html="transparencyHtml" />

    <div
      class="btn my-2"
      draggable
      @dragstart="drag"
    >
      Drop me in a workflow server
    </div>

    <a
      class="big-btn no-underline"
      :href="transparencyURL"
      download="transparency.tar.gz"
    >
      Download
    </a>
  </div>
</template>

<script lang="ts">
  import { Vue, Component, Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'

import axios from 'axios'
import _ from 'lodash/fp'

function displayRow ({ index, context, g1, g2, refSim, patternSim, quality }) {
  return {
    index,
    pattern: {
      refSim,
      patternSim,
      style_context_bar: `width: 3px; position: absolute; left: ${percentage(refSim)};`,
      style_progress: `width: ${percentage(patternSim)}; background: rgb(${colorPercentage([221, 75, 57], [0, 166, 90], patternSim).join(',')});`,
      quality: Number.parseFloat(quality)
    },
    change: (patternSim - refSim) / refSim,
    g1,
    g2,
    context
  }
}

function percentage (val) {
  return `${_.round(_.multiply(100, val))}%`
}

function colorPercentage ([r1, g1, b1], [r2, g2, b2], percentage) {
  const percent = (a, b) => a + (b - a) * percentage
  return [percent(r1, r2), percent(g1, g2), percent(b1, b2)]
}

@Component
export default class Transparency extends Vue {
  @Prop(Object) transparencyData
  @Prop(String) transparencyHtml

  @State userID: string
  @State jobID: string

  get rows () {
    return this.transparencyData.results.map(displayRow)
  }

  get transparencyURL () {
    return `/api/results/${this.userID}/${this.jobID}/transparency`
  }

  drag ({ dataTransfer: dt }) {
    dt.setData('data', JSON.stringify({
      workflow: {
        url: `${location.protocol}//${location.host}/api/results/${this.userID}/${this.jobID}/workflow`,
        description: 'Remotely runs the Debunk algorithm and compares results.',
        name: 'Debunk: run and compare'
      },
      instance: {
        url: `${location.protocol}//${location.host}/api/results/${this.userID}/${this.jobID}/args`,
        description: '',
        name: ''
      }
    }))
  }
}
</script>
